Package: dStruct
Type: Package
Title: Identifying differentially reactive regions from RNA structurome
        profiling data
Version: 1.19.0
Depends: R (>= 4.1)
Authors@R: c(
    person("Krishna", "Choudhary", role=c("aut", "cre"), 
        email="kchoudhary@ucdavis.edu", comment = c(ORCID = "0000-0002-7966-1527")),
    person("Sharon", "Aviran", role=c("aut"), 
        email="saviran@ucdavis.edu", comment = c(ORCID = "0000-0003-1872-9820")))
Description: dStruct identifies differentially reactive regions from RNA structurome profiling data. dStruct is compatible with a broad range of structurome profiling technologies, e.g., SHAPE-MaP, DMS-MaPseq, Structure-Seq, SHAPE-Seq, etc. See Choudhary et al., Genome Biology, 2019 for the underlying method.
Imports: zoo, ggplot2, purrr, reshape2, parallel, IRanges, S4Vectors,
        rlang, grDevices, stats, utils
License: GPL (>= 2)
biocViews: StatisticalMethod, StructuralPrediction, Sequencing,
        Software
URL: https://github.com/dataMaster-Kris/dStruct
BugReports: https://github.com/dataMaster-Kris/dStruct/issues
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
Suggests: BiocStyle, knitr, rmarkdown, tidyverse, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/dStruct
git_branch: devel
git_last_commit: 952c590
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:25:38 UTC; biocbuild
Author: Krishna Choudhary [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-7966-1527>),
  Sharon Aviran [aut] (ORCID: <https://orcid.org/0000-0003-1872-9820>)
Maintainer: Krishna Choudhary <kchoudhary@ucdavis.edu>

#' @title Performs de novo or guided discovery of differentially reactive regions for transcriptome-wide data.
#'
#' @description This function provides a convenient way to call the dStruct or
#' dStructGuided functions for multiple transcripts simultaneously. By default,
#' the transcripts are processed in using multiple parallel processes if available.
#'
#' @param reps_A Number of replicates of group A.
#' @param reps_B Number of replicates of group B.
#' @param rl List of dataframes of reactivities for each sample.
#' @param min_length Minimum length of constructed regions.
#' @param check_signal_strength Logical, if TRUE, construction of regions must be based on nucleotides that have a minimum absolute value of reactivity.
#' @param check_nucs Logical, if TRUE, constructed regions must have a minimum number of nucleotides participating in Wilcoxon signed rank test.
#' @param check_quality Logical, if TRUE, check constructed regions for quality.
#' @param batches Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.
#' @param between_combs Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.
#' @param within_combs Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.
#' @param quality Worst allowed quality for a region to be tested.
#' @param evidence Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.
#' @param signal_strength Threshold for minimum signal strength.
#' @param ind_regions Logical, if TRUE, test each region found in the transcript separately.
#' @param gap Integer. Join regions if they are separated by these many nucleotides.
#' @param processes Number of parallel processes to use.
#' @param method Character specifying either guided or de novo discovery approach.
#' @param proximity_assisted Logical, if TRUE, proximally located regions are tested together.
#' @param proximity Maximum distance between constructed regions for them to be considered proximal.
#' @param proximity_defined_length If performing a "proximity-assisted" test, minimum end-to-end length of a region to be tested.
#' @return Constructs regions, reports p-value and median difference of between-group and within-group d-scores for each region, and FDR for them.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA structurome
#' profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' @examples
#' #Load data from Lai et al., 2019
#' data(lai2019)
#'
#' #Run dStruct in de novo discovery mode for all the transcripts in this data in one step.
#' dStructome(lai2019, 3, 2, batches= TRUE, min_length = 21,
#'     between_combs = data.frame(c("A3", "B1", "B2")),
#'     within_combs = data.frame(c("A1", "A2", "A3")),
#'     ind_regions = TRUE, processes = 1)
#'
#' #Load data from Wan et al., 2014
#' data(wan2014)
#'
#' #Run dStruct in guide discovery mode for all the transcript regions in this data in one step.
#' dStructome(wan2014, reps_A = 2, reps_B = 1, method = "guided", processes = 1)
#' @export
#' @importFrom stats p.adjust
dStructome <- function(rl, reps_A, reps_B, batches= FALSE, min_length = 11,
                       check_signal_strength = TRUE, check_nucs = TRUE, check_quality = TRUE,
                       quality = "auto", evidence = 0, signal_strength = 0.1,
                       within_combs = NULL, between_combs= NULL, ind_regions = TRUE, gap = 1,
                       processes = "auto", method = "denovo",
                       proximity_assisted = FALSE, proximity = 10,
                       proximity_defined_length = 30) {

  if (is.null(names(rl)) | (length(names(rl)) != length(rl))) stop("List \'rl\' supplied to dStructome without transcript names.")

  if (processes == "auto") {
    processes <- parallel::detectCores()-1
  } else {
    processes <- as.numeric(processes)
    if ((processes %% 1 != 0) | (processes < 0)) stop("parameter \'processes\' supplied to dStructome must be positive integer.")
  }

  if (is.null(between_combs) | is.null(within_combs)) idcombs <- getCombs(reps_A, reps_B, batches,
                                                                          between_combs, within_combs)
  if (is.null(between_combs)) between_combs <- idcombs$between_combs
  if (is.null(within_combs)) within_combs <- idcombs$within_combs

  if (method == "guided") {

    result <- parallel::mcmapply(function(x) {
      dStructGuided(x, reps_A, reps_B, batches,
                    within_combs, between_combs, check_quality,
                    quality, evidence)
    }, rl, mc.cores=processes)

    pvals <- result[1, ]
    names(pvals) <- NULL
    del_d <- result[2, ]
    names(del_d) <- NULL
    res_df <- data.frame(t = names(rl), pval = pvals, del_d = del_d)
    res_df <- subset(res_df, !is.na(res_df$pval))
    res_df$FDR <- stats::p.adjust(res_df$pval, "BH")

    rownames(res_df) <- NULL

  } else if (method == "denovo") {

    result <- parallel::mcmapply(function(x) {
      dStruct(x, reps_A, reps_B, batches, min_length,
              check_signal_strength, check_nucs, check_quality,
              quality, evidence, signal_strength,
              within_combs, between_combs, ind_regions, gap,
              get_FDR = FALSE, proximity_assisted, proximity,
              proximity_defined_length)
    }, rl, mc.cores=processes, SIMPLIFY = FALSE)

    if (ind_regions) {
      res_df <- IRanges::IRanges()
      for (i in 1:length(result)) {
        if (is.null(result[[i]])) next
        this_res <- result[[i]]
        S4Vectors::mcols(this_res) <- data.frame(S4Vectors::mcols(this_res),
                                                 t = names(result)[i])
        res_df <- c(res_df, this_res)
      }

      S4Vectors::mcols(res_df) <- data.frame(S4Vectors::mcols(res_df),
                                             FDR = stats::p.adjust(S4Vectors::mcols(res_df)$pval,
                                                            "BH"))
    } else {
      res_df <- IRanges::IRanges()
      pvals_and_del_d <- data.frame(t= NA, pval= NA, del_d = NA)
      for (i in 1:length(result)) {
        if (is.null(result[[i]])) next
        pvals_and_del_d <- rbind(pvals_and_del_d,
                                 data.frame(t =  names(result)[i], pval = result[[i]]$pval,
                                            del_d = result[[i]]$del_d), stringsAsFactors= FALSE)
        this_res <- result[[i]]$regions
        S4Vectors::mcols(this_res) <- data.frame(t = rep(names(result)[i],
                                                         length(this_res)))
        res_df <- c(res_df, this_res)
      }

      pvals_and_del_d <- pvals_and_del_d[-1, ]

      pvals_and_del_d$FDR <- stats::p.adjust(pvals_and_del_d$pval, "BH")

      res_df_with_pvals <- IRanges::IRanges()
      for (i in unique(S4Vectors::mcols(res_df)$t)) {
        this_res <- res_df[S4Vectors::mcols(res_df)$t == i]
        S4Vectors::mcols(this_res) <- data.frame(t = rep(i, length(this_res)),
                                                 pval = rep(subset(pvals_and_del_d,
                                                                   t == i)$pval,
                                                            length(this_res)),
                                                 del_d = rep(subset(pvals_and_del_d,
                                                                    t == i)$del_d,
                                                             length(this_res)),
                                                 FDR = rep(subset(pvals_and_del_d,
                                                                  t == i)$FDR,
                                                           length(this_res)))
        res_df_with_pvals <- c(res_df_with_pvals, this_res)
      }

      res_df <- res_df_with_pvals
    }
  }

  return(res_df)

}

#' @title Performs de novo discovery of differentially reactive regions.
#'
#' @description This function takes reactivity profiles for samples of two groups
#' as input and identifies differentially reactive regions in three steps (see
#' Choudhary et al., \emph{Genome Biology}, 2019 for details). First, it regroups
#' the samples into homogeneous and heteregenous sub-groups, which are used to
#' compute the within-group and between-group nucleotide-wise \emph{d} scores.
#' Second, smoothed between- and within-group \emph{d} score profiles are compared
#' to construct candidate differential regions. Finally, unsmoothed between- and
#' within-group \emph{d} scores are compared using the Wilcoxon signed-rank test.
#' The resulting p-values quantify the significance of difference in reactivity
#' patterns between the two input groups.
#'
#' @param reps_A Number of replicates of group A.
#' @param reps_B Number of replicates of group B.
#' @param rdf Dataframe of reactivities for each sample.
#' @param min_length Minimum length of constructed regions.
#' @param check_signal_strength Logical, if TRUE, construction of regions must be based on nucleotides that have a minimum absolute value of reactivity.
#' @param check_nucs Logical, if TRUE, constructed regions must have a minimum number of nucleotides participating in Wilcoxon signed rank test.
#' @param check_quality Logical, if TRUE, check constructed regions for quality.
#' @param batches Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.
#' @param between_combs Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.
#' @param within_combs Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.
#' @param quality Worst allowed quality for a region to be tested.
#' @param evidence Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.
#' @param signal_strength Threshold for minimum signal strength.
#' @param ind_regions Logical, if TRUE, test each region found in the transcript separately.
#' @param gap Integer. Join regions if they are separated by these many nucleotides.
#' @param get_FDR Logical, if FALSE, FDR is not reported.
#' @param proximity_assisted Logical, if TRUE, proximally located regions are tested together.
#' @param proximity Maximum distance between constructed regions for them to be considered proximal.
#' @param proximity_defined_length If performing a "proximity-assisted" test, minimum end-to-end length of a region to be tested.
#' @return Constructs regions, reports p-value and median difference of between-group and within-group d-scores for each region, and FDR for them.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA structurome
#' profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' @examples
#' #Load data from Lai et al., 2019
#' data(lai2019)
#'
#' #Run dStruct in de novo discovery mode for a transcript with id YAL042W.
#' dStruct(rdf = lai2019[["YAL042W"]], reps_A = 3, reps_B = 2,
#'     batches = TRUE, min_length = 21,
#'     between_combs = data.frame(c("A3", "B1", "B2")),
#'     within_combs = data.frame(c("A1", "A2", "A3")),
#'     ind_regions = TRUE)
#' @export
#' @importFrom stats median p.adjust wilcox.test
dStruct <- function(rdf, reps_A, reps_B, batches = FALSE, min_length = 11,
                    check_signal_strength = TRUE, check_nucs = TRUE, check_quality = TRUE,
                    quality = "auto", evidence = 0, signal_strength = 0.1,
                    within_combs = NULL, between_combs= NULL, ind_regions = TRUE, gap = 1,
                    get_FDR = TRUE, proximity_assisted = FALSE, proximity = 10,
                    proximity_defined_length = 30) {

  if ((quality == "auto") & min(c(reps_A, reps_B)) != 1) quality <- 0.5 else if (quality == "auto") quality <- 0.2
  if (is.null(between_combs) | is.null(within_combs)) idcombs <- getCombs(reps_A, reps_B, batches,
                                                                          between_combs, within_combs)
  if (is.null(between_combs)) between_combs <- idcombs$between_combs
  if (is.null(within_combs)) within_combs <- idcombs$within_combs

  d_within <- dCombs(rdf, within_combs)
  d_between <- dCombs(rdf, between_combs)

  to_test <- getRegions(d_within, d_between, rdf, min_length,
                        check_signal_strength, check_nucs, check_quality,
                        quality, evidence, signal_strength)

  if (is.null(to_test) | !length(to_test)) return(NULL)

  contigs_test <- getContigRegions(to_test, gap)

  if (!ind_regions & !proximity_assisted) {

    result <- tryCatch({
      c(stats::wilcox.test(d_within[to_test], d_between[to_test],
                    alternative = "less", paired= TRUE)$p.value,
        stats::median(d_between[to_test] - d_within[to_test],
               na.rm = TRUE))
    }, error= function(e) {
      #Place holder for those transcripts that can't be tested due to insufficient data points.
      result <- c(NA, NA)
    })

    result <- list(regions= contigs_test, pval = result[1],
                   del_d = result[2])

  } else if (!proximity_assisted) {

    pvals <- c()
    del_d <- c()
    for (i in 1:length(contigs_test)) {
      curr_res <- tryCatch({
        c(stats::wilcox.test(d_within[IRanges::start(contigs_test)[i]:IRanges::end(contigs_test)[i]],
                      d_between[IRanges::start(contigs_test)[i]:IRanges::end(contigs_test)[i]],
                      alternative = "less", paired= TRUE)$p.value,
          stats::median(d_between[IRanges::start(contigs_test)[i]:IRanges::end(contigs_test)[i]] -
                   d_within[IRanges::start(contigs_test)[i]:IRanges::end(contigs_test)[i]],
                 na.rm = TRUE))

      }, error= function(e) {
        #Place holder for those transcripts that can't be tested due to insufficient data points.
        result <- c(NA, NA)
      })
      pvals <- c(pvals, curr_res[1])
      del_d <- c(del_d, curr_res[2])

    }

    S4Vectors::mcols(contigs_test) <- data.frame(pval = pvals,
                                                 del_d = del_d)
    if (get_FDR) S4Vectors::mcols(contigs_test) <- data.frame(S4Vectors::mcols(contigs_test),
                                                              FDR = stats::p.adjust(pvals, "BH"))
    result <- contigs_test
  } else {

    proximal_contigs <- which(IRanges::start(contigs_test)[-1]-
                                IRanges::end(contigs_test)[-length(contigs_test)] < proximity)+1

    if (length(proximal_contigs)) {
      proximally_tied_regs <- getContigRegions(proximal_contigs)
      IRanges::start(proximally_tied_regs) <- IRanges::start(proximally_tied_regs) - 1
      proximal_contigs <- unlist(apply(data.frame(proximally_tied_regs), 1,
                                       function(x) x[1]:x[2]))
      non_proximal <- setdiff(1:length(contigs_test),
                              proximal_contigs)
    } else {
      non_proximal <- 1:length(contigs_test)
    }

    which_too_short <- IRanges::width(contigs_test[non_proximal]) < proximity_defined_length

    pvals <- c()
    del_d <- c()
    for (i in non_proximal) {

      curr_nucs <- IRanges::start(contigs_test)[i]:IRanges::end(contigs_test)[i]
      if (length(curr_nucs) < proximity_defined_length) {
        curr_res <- c(NA, NA)
      } else {
        curr_res <- tryCatch({
          c(stats::wilcox.test(d_within[curr_nucs],
                        d_between[curr_nucs],
                        alternative = "less", paired= TRUE)$p.value,
            stats::median(d_between[curr_nucs] - d_within[curr_nucs],
                   na.rm = TRUE))

        }, error= function(e) {
          #Place holder for those transcripts that can't be tested due to insufficient data points.
          result <- c(NA, NA)
        })
      }

      pvals <- c(pvals, curr_res[1])
      del_d <- c(del_d, curr_res[2])
    }

    if (length(proximal_contigs)) {

      proximity_defined_regs <- IRanges::IRanges()

      for (i in 1:length(proximally_tied_regs)) {
        curr <- contigs_test[IRanges::start(proximally_tied_regs)[i]:IRanges::end(proximally_tied_regs)[i]]
        curr_nucs <- unlist(apply(data.frame(curr), 1,
                                  function(x) x[1]:x[2]))
        curr_length <- max(curr_nucs) - min(curr_nucs) + 1

        if (curr_length >= proximity_defined_length) {
          curr_res <- tryCatch({
            c(stats::wilcox.test(d_within[curr_nucs],
                          d_between[curr_nucs],
                          alternative = "less", paired= TRUE)$p.value,
              stats::median(d_between[curr_nucs] - d_within[curr_nucs],
                     na.rm = TRUE))

          }, error= function(e) {
            #Place holder for those transcripts that can't be tested due to insufficient data points.
            result <- c(NA, NA)
          })
        } else {
          curr_res <- c(NA, NA)
        }

        curr_ir <- IRanges::IRanges(start = min(IRanges::start(curr)),
                                    end = max(IRanges::end(curr)))

        S4Vectors::mcols(curr_ir) <- data.frame(subStart = paste(IRanges::start(curr),
                                                                 collapse = ","),
                                                subEnd = paste(IRanges::end(curr),
                                                               collapse = ","))

        proximity_defined_regs <- c(proximity_defined_regs, curr_ir)
        pvals <- c(pvals, curr_res[1])
        del_d <- c(del_d, curr_res[2])
      }

      contigs_test <- c(contigs_test[non_proximal, ],
                        proximity_defined_regs)
    }

    S4Vectors::mcols(contigs_test) <- data.frame(S4Vectors::mcols(contigs_test),
                                                 pval = pvals, del_d = del_d)
    if (get_FDR) S4Vectors::mcols(contigs_test) <- data.frame(S4Vectors::mcols(contigs_test),
                                                              FDR = stats::p.adjust(pvals, "BH"))
    result <- contigs_test
  }

  return(result)

}

data("lai2019")

test_that("Previous result is reproduced when testing individual regions.", {
  #Previously obtained results for YAL042W
  nowResult <- suppressWarnings(dStruct(rdf = lai2019[["YAL042W"]],
                       reps_A = 3, reps_B = 2,
                       batches = TRUE, min_length = 21,
                       between_combs = data.frame(c("A3", "B1", "B2")),
                       within_combs = data.frame(c("A1", "A2", "A3")),
                       ind_regions = TRUE))

  expect_true(all(IRanges::start(nowResult) == c(19, 530, 583, 1122, 1187)))
  expect_true(all(IRanges::end(nowResult) == c(146, 553, 632, 1177, 1218)))

  pvals_to_compare <- data.frame(nowResult = nowResult@elementMetadata$pval,
                                 previous = c(0.0001419124,
                                              0.0767881983, 0.0228964197,
                                              0.0353501385, 0.0164846906))
  apply(pvals_to_compare, 1, function(x) {
    names(x) <- NULL
    expect_equal(x[1], x[2],
                 tolerance = 10^-1)
  })

  delD_to_compare <- data.frame(nowResult = nowResult@elementMetadata$del_d,
                                previous = c(0.11071808,
                                             0.07939060, 0.01748423,
                                             0.02047984, 0.09202706))
  apply(delD_to_compare, 1, function(x) {
    names(x) <- NULL
    expect_equal(x[1], x[2],
                 tolerance = 10^-1)
  })

  fdr_to_compare <- data.frame(nowResult = nowResult@elementMetadata$FDR,
                                previous = c(0.0007095618,
                                             0.0767881983, 0.0381606995,
                                             0.0441876731, 0.0381606995))
  apply(fdr_to_compare, 1, function(x) {
    names(x) <- NULL
    expect_equal(x[1], x[2],
                 tolerance = 10^-1)
  })

})


test_that("Previous result is reproduced when testing regions of a transcript collectively.", {
  #Previously obtained results for YAL042W
  nowResult <- suppressWarnings(dStruct(rdf = lai2019[["YAL042W"]],
                                        reps_A = 3, reps_B = 2,
                                        batches = TRUE, min_length = 21,
                                        between_combs = data.frame(c("A3", "B1", "B2")),
                                        within_combs = data.frame(c("A1", "A2", "A3")),
                                        ind_regions = FALSE))

  expect_true(is.list(nowResult))
  expect_true(all(names(nowResult) == c("regions", "pval", "del_d")))

  expect_true(all(IRanges::start(nowResult$regions) == c(19, 530, 583, 1122, 1187)))
  expect_true(all(IRanges::end(nowResult$regions) == c(146, 553, 632, 1177, 1218)))

  expect_equal(nowResult$pval, 5.997025e-08,
               tolerance = 10^-1)

  expect_equal(nowResult$del_d, 0.09044452,
               tolerance = 10^-1)

})


test_that("Previous result is reproduced when testing regions of a transcript individually. If any regions are found within a certain distance of each other, they are tested collectively.", {
  #Previously obtained results for YAL042W
  nowResult <- suppressWarnings(dStruct(rdf = lai2019[["YAL042W"]],
                                        reps_A = 3, reps_B = 2,
                                        batches = TRUE, min_length = 21,
                                        between_combs = data.frame(c("A3", "B1", "B2")),
                                        within_combs = data.frame(c("A1", "A2", "A3")),
                                        ind_regions = FALSE,
                                        proximity = 15,
                                        proximity_assisted = TRUE))

  expect_true(isS4(nowResult))
  expect_true(all(names(nowResult@elementMetadata) ==
                    c("subStart", "subEnd", "pval", "del_d", "FDR")))

  expect_true(all(IRanges::start(nowResult) == c(19, 530, 583, 1122)))
  expect_true(all(IRanges::end(nowResult) == c(146, 553, 632, 1218)))

  pvals_to_compare <- data.frame(nowResult = nowResult@elementMetadata$pval,
                                 previous = c(0.0001419124,
                                              NA, 0.0228964197,
                                              0.0018650048))
  apply(pvals_to_compare, 1, function(x) {
    names(x) <- NULL
    expect_equal(x[1], x[2],
                 tolerance = 10^-1)
  })

  delD_to_compare <- data.frame(nowResult = nowResult@elementMetadata$del_d,
                                previous = c(0.11071808,
                                             NA, 0.01748423,
                                             0.09044452))
  apply(delD_to_compare, 1, function(x) {
    names(x) <- NULL
    expect_equal(x[1], x[2],
                 tolerance = 10^-1)
  })

  fdr_to_compare <- data.frame(nowResult = nowResult@elementMetadata$FDR,
                               previous = c(0.0004257371,
                                            NA, 0.0228964197,
                                            0.0027975072))
  apply(fdr_to_compare, 1, function(x) {
    names(x) <- NULL
    expect_equal(x[1], x[2],
                 tolerance = 10^-1)
  })

})

#' @title Assesses within-group or between-group variation.
#'
#' @description Given the reactivity profiles for a transcript from multiple samples,
#' and a list of sample identifiers, this function computes the dissimilarity of
#' reactivity scores between the specified samples. These are returned as a sequence of
#' nucleotide-wise \emph{d} scores.
#'
#' @param rdf Data.frame of reactivities for each sample.
#' @param combs Data.frame with each column containing groupings of samples.
#' @return Nucleotide-wise d scores.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA structurome
#' profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' @examples
#' #Example of a data frame with reactivities.
#' reacs <- data.frame(matrix(runif(30, 0, 10), 10, 3))
#'
#' #The columns of data frame with must indicate sample grouping and id.
#' colnames(reacs) <- c("A1", "A2", "B1")
#'
#' #Get nucleotide-wise dissimilarity scores for a set of samples.
#' dCombs(rdf = reacs, combs = data.frame(c("A1", "B1")))
#' @export
dCombs <- function(rdf, combs) {
  d <- matrix(, nrow(rdf), ncol(combs))
  for (i in 1:ncol(combs)) {
    curr_comb <- as.character(combs[, i])
    curr_dat <- rdf[, curr_comb]
    d[, i] <- calcDis(curr_dat)
  }

  d <- apply(d, 1, mean, na.rm=TRUE)
  return(d)
}

test_that("There is one d-score per nucleotide", {
  reacs <- data.frame(matrix(runif(30, 0, 10), 10, 3))
  colnames(reacs) <- c("A1", "A2", "B1")

  expect_true(length(dCombs(reacs, getCombs(2, 1)$between_combs)) ==
                nrow(reacs))
})

data("lai2019")

test_that("Previous result is reproduced.", {
  #Previously obtained results for YAL042W

  combs <- list(between_combs = data.frame(c("A3", "B1", "B2")),
                within_combs = data.frame(c("A1", "A2", "A3")))
  dWithin <- dCombs(lai2019[["YAL042W"]], combs$within_combs)
  dBetween <- dCombs(lai2019[["YAL042W"]], combs$between_combs)
  regs <- getContigRegions(getRegions(dWithin,
                              dBetween, lai2019[["YAL042W"]], min_length = 21))

  expect_true(all(IRanges::start(regs) == c(19, 530, 583, 1122, 1187)))
  expect_true(all(IRanges::end(regs) == c(146, 553, 632, 1177, 1218)))
})

#' @title Returns normalizer for reactivity vector.
#'
#' @description Assesses normalization factor for raw reactivities using the 2-8 \%
#' method. Given a reactivity profile, first, remove 2\% of the nucleotides with
#' the highest reactivities. Then, the normalization factor is the mean of reactivities
#' of the 8\% of the nucleotides with the next highest reactivities.
#'
#' @param raw.estimates A vector of raw reactivities.
#' @return The normalization factor.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Low JT, Weeks KM. SHAPE-directed RNA secondary structure prediction.
#' \emph{Methods}. 2010; 52(2):150–8.
#'
#' Sloma MF, Mathews DH, Chen SJ, Burke-Aguero DH. Chapter four – improving RNA
#' secondary structure prediction with structure mapping data. In:
#' \emph{Methods in Enzymology}, vol. 553. Cambridge: Academic Press: 2015. p. 91–114.
#'
#' Choudhary K, Deng F, Aviran S. Comparative and integrative analysis of RNA
#' structural profiling data: current practices and emerging questions. \emph{Quant Biol.}
#' 2017; 5(1):3–24.
#'
#' @examples
#' normalizer(c(NA, rnorm(20, 0.5, 0.3), NA, -999))
#' @export
normalizer <- function(raw.estimates) {
  raw.estimates[which(raw.estimates == -999)] <- NA
  sorted <- raw.estimates[order(raw.estimates)]
  if (any(is.na(sorted))) {
    normalize.range <- c(round((min(which(is.na(sorted)))-1) * .9), round((min(which(is.na(sorted)))-1) * .98))
  } else {
    normalize.range <- c(round(length(sorted) * .9), round(length(sorted)* .98))
  }
  normalizer <- mean(sorted[normalize.range[1]:normalize.range[2]])
  return(normalizer)
}

#' @title Identifies subgroupings of replicates for assessing within-group and between-group variation.
#'
#' @description Regroup all the samples of A and B groups into homogoneous and
#' heterogeneous sub-groups. Each homogenous sub-group contains replicates of either
#' group A only or group B only. Each heterogeneous sub-group has a mix of samples from
#' both the groups A and B.
#'
#' @param reps_A Number of replicates of group A.
#' @param reps_B Number of replicates of group B.
#' @param batches Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.
#' @param between_combs Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.
#' @param within_combs Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.
#' @return List of two dataframes, containing groupings for within-group and between-group variation.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA
#' structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' @examples
#' #Get heterogeneous and homogeneous set combinations of samples when there are 2 samples of group A and 1 of group B.
#' getCombs(2, 1)
#' @export
#' @importFrom utils combn
getCombs <- function(reps_A, reps_B, batches = FALSE, between_combs= NULL, within_combs= NULL) {
  if ((is.null(within_combs) & !is.null(between_combs)) | (is.null(between_combs) & !is.null(within_combs))) stop("Homogeneous and heterogeneous sets should either both be null or both be specified with equal number of samples in each set.")
  if (!is.null(within_combs)) if (nrow(between_combs)!=nrow(within_combs)) stop("Heterogeneous and homogeneous sets should have equal number of samples.")

  set_membership <- if (is.null(within_combs)) max(c(reps_A, reps_B)) else nrow(within_combs)
  while ( (set_membership/2 > min(c(reps_A, reps_B))) | (set_membership %% 2 != 0) ) {

    if (set_membership  == 3) break

    set_membership <- set_membership - 1

  }

  all_combs <- utils::combn(c(paste0("A", 1:reps_A), paste0("B", 1:reps_B)),
                    set_membership)


  if (batches) {
    invalid_due_to_batch <- apply(all_combs, 2, function(x) {
      curr_reps <- mapply(function(y) y[2], strsplit(x, split= ""))
      return(length(unique(curr_reps)) < length(curr_reps))
    })

    all_combs <- all_combs[, !invalid_due_to_batch] #Removes sets that have multiple samples from the same batch.
  }

  if (is.null(within_combs)) {
    if (min(c(reps_A, reps_B)) >= set_membership) {
      within_combs <- cbind(combn(paste0("A", 1:reps_A), set_membership),
                           combn(paste0("B", 1:reps_B), set_membership))
    } else if (reps_A >= set_membership) {
      within_combs <- cbind(combn(paste0("A", 1:reps_A), set_membership))
    } else if (reps_B >= set_membership) {
      within_combs <- cbind(combn(paste0("B", 1:reps_B), set_membership))
    }

  }


  if (is.null(between_combs)) {
    between_combs_not_in <- which(apply(all_combs, 2, paste0, collapse= "") %in% apply(within_combs, 2, paste0, collapse= ""))
    between_combs <- data.frame(all_combs[, -between_combs_not_in])
    deg_of_heterogeneity <- apply(between_combs, 2, function(x) {
      curr_reps <- mapply(function(y) y[1], strsplit(x, split= ""))
      gA <- length(which(curr_reps == "A"))
      gB <- length(which(curr_reps == "B"))
      return(gA*gB/(gA + gB))
    })

    to_keep <- which(deg_of_heterogeneity == max(deg_of_heterogeneity))
    between_combs <- data.frame(between_combs[, to_keep])
  }

  return(list(between_combs= between_combs, within_combs= within_combs))
}

test_that("Return is a list", {
  expect_true(is.list(getCombs(2, 1)) & !is.data.frame(getCombs(2, 1)))
  expect_true(is.list(getCombs(3, 4, batches = TRUE)) &
                !is.data.frame(getCombs(3, 4, batches = TRUE)))
  expect_true(is.list(getCombs(2, 1, batches = TRUE)) &
                !is.data.frame(getCombs(2, 1,
                                        between_combs = data.frame("A1", "B1"),
                                        within_combs = data.frame("A1", "A2"))))
  expect_true(all(names(getCombs(2, 4)) == c("between_combs", "within_combs")))
})

test_that("Elements of the returned list have equal number of rows", {
  tester <- function(test_next) expect_true(nrow(test_next[[1]]) == nrow(test_next[[2]]))

  test_next <- getCombs(2, 1)
  tester(test_next)

  test_next <- getCombs(4, 3, batches = TRUE)
  tester(test_next)

  test_next <- getCombs(7, 7)
  tester(test_next)
})

test_that("Homogeneous sets have samples of the same group", {
  tester <- function(test_next) expect_true(all(
    apply(test_next$within_combs, 2,
          function(x) length(unique(substr(x, 1, 1)))
          == 1)))

  test_next <- getCombs(2, 1)
  tester(test_next)

  test_next <- getCombs(4, 3, batches = TRUE)
  tester(test_next)

  test_next <- getCombs(7, 7)
  tester(test_next)
})

test_that("Heterogeneous sets have samples of both groups", {
  tester <- function(test_next) expect_true(all(
    apply(test_next$between_combs, 2,
          function(x) length(unique(substr(x, 1, 1)))
          == 2)))

  test_next <- getCombs(2, 1)
  tester(test_next)

  test_next <- getCombs(4, 3, batches = TRUE)
  tester(test_next)

  test_next <- getCombs(7, 7)
  tester(test_next)
})

#' @title Performs guided discovery of differentially reactive regions.
#'
#' @description This function takes as input reactivity profiles for a
#' transcript region from samples of two groups. First, it regroups the samples
#' into homogeneous and heteregenous sub-groups, which are used to compute the
#' within-group and between-group nucleotide-wise \emph{d} scores. If the
#' region meets the quality criteria, the between- and within-group \emph{d}
#' scores are compared using the Wilcoxon signed-rank test.
#' The resulting p-values quantify the significance of difference in reactivity
#' patterns between the two input groups.
#'
#' @param reps_A Number of replicates of group A.
#' @param reps_B Number of replicates of group B.
#' @param rdf Dataframe of reactivities for each sample. Each column must be labelled as A1, A2, ..., B1, B2, ...
#' @param batches Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.
#' @param between_combs Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.
#' @param within_combs Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.
#' @param check_quality Logical, if TRUE, check regions for quality.
#' @param quality Worst allowed quality for a region to be tested.
#' @param evidence Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.
#' @return p-value for the tested region (estimated using one-sided Wilcoxon signed rank test) and the median of nucleotide-wise difference of between-group and within-group d-scores.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA
#' structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' @examples
#' #Load Wan et al., 2014 data
#' data(wan2014)
#'
#' #Run dStruct in the guided mode on first region in wan2014.
#' dStructGuided(wan2014[[1]], reps_A = 2, reps_B = 1)
#' @export
#' @importFrom stats median wilcox.test
dStructGuided <- function(rdf, reps_A, reps_B, batches = FALSE,
                           within_combs = NULL, between_combs= NULL, check_quality = TRUE,
                           quality = "auto", evidence = 0) {

  if ((quality == "auto") & min(c(reps_A, reps_B)) != 1) quality <- 0.5 else if (quality== "auto") quality <- 0.2
  if (is.null(between_combs) | is.null(within_combs)) idcombs <- getCombs(reps_A, reps_B, batches,
                                                                         between_combs, within_combs)
  if (is.null(between_combs)) between_combs <- idcombs$between_combs
  if (is.null(within_combs)) within_combs <- idcombs$within_combs

  d_within <- dCombs(rdf, within_combs)
  d_between <- dCombs(rdf, between_combs)

  if (mean(d_within, na.rm = TRUE) > quality) return(c(NA, NA))
  if (stats::median(d_between - d_within, na.rm = TRUE) < evidence) return(c(NA, NA))

  result <- tryCatch({
    c(pval = stats::wilcox.test(d_within, d_between,
                  alternative = "less", paired= TRUE)$p.value,
      del_d = stats::median(d_between - d_within, na.rm = TRUE)
    )
  }, error= function(e) {
    #Place holder for those transcripts that can't be tested due to error.
    result <- c(pval = NA, del_d= NA)
  })

  return(result)

}

data(wan2014)

test_that("Previous result is reproduced when testing a region.", {
  #Previously obtained result for 1__NM_000146__357__367
  nowResult <- dStructGuided(wan2014[[1]],
                              reps_A = 2, reps_B = 1)

  expect_true(all(names(nowResult) == c("pval", "del_d")))

  expect_equal(nowResult[1], c(pval = 0.16015625), tolerance = 10^-1)
  expect_equal(nowResult[2], c(del_d = 0.02291958), tolerance = 10^-1)
})

#' @title Identifies contiguous regions from a list of nucleotide indices.
#'
#' @description Given a sequence of nucleotide indices, this function returns integer ranges covered by the indices. There is an option to merge ranges if they are separated by less than a user-specified distance.
#'
#' @param x A vector of integers.
#' @param gap Include gaps in the ranges if they are shorter than or equal to this length.
#' @return IRanges object storing start and end sites of continguous regions.
#'
#' @author Krishna Choudhary
#'
#' @examples
#' #Convert an integer vector of nucleotide positions to an IRanges object containing the coordinates of contiguous regions.
#' nucleotide_positions <- c(1, 3, 2, 8, 4:7, 11:20)
#' getContigRegions(nucleotide_positions)
#'
#' #Merge regions if their end points are within 3 nt of each other.
#' getContigRegions(nucleotide_positions, gap = 3)
#' @export
getContigRegions <- function(x, gap = 0) {
  if ((gap %% 1 != 0) | (gap < 0)) stop("parameter \'gap\' supplied to getContigRegions must be positive integer.")
  x <- sort(x)
  x <- replace(logical(max(x)), x, TRUE)
  ir <- IRanges::IRanges(x)

  if (gap) {
    gir <- IRanges::gaps(ir)
    gir <- gir[IRanges::width(gir) <= gap]
    ir <- IRanges::reduce(c(ir, gir))
  }

  return(ir)
}

test_that("Contiguous region boundaries are properly identified.", {
  tester <- function(x, expected_starts, expected_stops) {
    all(c(IRanges::start(x) == expected_starts,
          IRanges::end(x) == expected_stops))
  }

  test_next <- getContigRegions(c(1:10, 11:20))
  expect_true(tester(test_next, 1, 20))

  test_next <- getContigRegions(c(1:10, 12:20))
  expect_true(tester(test_next, c(1, 12), c(10, 20)))

  test_next <- getContigRegions(c(1:10, 12:20), gap = 1)
  expect_true(tester(test_next, 1, 20))

  test_next <- getContigRegions(c(1:10, 13:20), gap = 1)
  expect_true(tester(test_next, c(1, 13), c(10, 20)))

  test_next <- getContigRegions(c(1:8, 15:20))
  expect_true(tester(test_next, c(1, 15), c(8, 20)))
})

#' @title \emph{Saccharomyces cerevisiae} Structure-seq data
#'
#' @description Data from a Structure-seq assay of five samples of \emph{S. cerevisiae}, three
#' of which were wild-type samples and two mutant samples. The data was
#' pre-processed to obtain DMS reactivities as described by Lai et al. (2019).
#'
#' @docType data
#'
#' @usage data("lai2019")
#'
#' @format An object of class \code{"list"}.
#'
#' @keywords datasets
#'
#' @references Lai et al. (2019) Genetics, Vol. 212, 153–174
#' (\href{https://doi.org/10.1534/genetics.119.302058}{Genetics})
#'
#' @source Raw data from \href{https://doi.org/10.1534/genetics.119.302058}{Lai et al., 2019} in processed form.
#'
#' @examples
#' data("lai2019")
"lai2019"

#' @title \emph{Homo sapiens} PARS data
#'
#' @description Data from a PARS assay of a family trio of mother, father, and child. The
#' data was pre-processed to obtain PARS scores as described in Choudhary et al. (2019).
#'
#' @docType data
#'
#' @usage data(wan2014)
#'
#' @format An object of class \code{"list"}.
#'
#' @keywords datasets
#'
#' @references Wan et al., Nature, 505, 706–709 (2014)
#' (\href{https://doi.org/10.1038/nature12946}{Nature})
#'
#' @source Counts data from \href{https://doi.org/10.1038/nature12946}{Wan et al., 2014} in processed form.
#'
#' @examples
#' data(wan2014)
"wan2014"

#' @title Calculates d score.
#'
#' @description \emph{d} score of a nucleotide is a measure of dissimilarity of its
#' normalized reactivity scores. Consider a transcript and its reactivity profiles
#' from a group of samples. Then, the \emph{d} score of a nucleotide is \eqn{(2/\pi)}
#' times the arc-tangent of the ratio of the sample standard deviation of its
#' reactivities to their mean.
#'
#' @param x A numeric vector or matrix.
#' @return If input is a numeric vector, a number is returned. For a matrix, a numeric vector is returned.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA
#' structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' Choudhary K, Shih NP, Deng F, Ledda M, Li B, Aviran S.
#' Metrics for rapid quality control in RNA structure probing experiments.
#' \emph{Bioinformatics}. 2016; 32(23):3575–3583.
#'
#' @examples
#' #Lower standard deviation of reactivites results in lower d-score.
#' calcDis(rnorm(10, 1, 0.2))
#' calcDis(rnorm(10, 1, 0.6))
#' @export
#' @importFrom stats sd
calcDis <- function(x) {
  dScore <- function(y) 2*(atan(abs(stats::sd(y)/mean(y))))/pi
  if (is.numeric(x)) return(dScore(x))
  return(apply(x, 1, function(y) dScore(y)))
}

test_that("For numeric vector input, return is a single value", {
  expect_equal(NaN, calcDis(c(0, 0)))
  expect_equal(1, calcDis(c(1, -1)))
  expect_equal(0, calcDis(c(1, 1)))
  expect_true(
    length(
      calcDis(
        runif(10, -10, 10)
        )
      ) == 1
    )
})

test_that("Output is always between 0 and 1", {
  expect_true(
    all(
      replicate(10,
                calcDis(runif(10,
                              runif(1, -20, 0),
                              runif(1, 0, 20)
                )
                )
      ) <= 1
    )
  )

  expect_true(
    all(
      replicate(10,
                calcDis(runif(10,
                              runif(1, -20, 0),
                              runif(1, 0, 20)
                )
                )
      ) >= 0
    )
  )

})

test_that("Vector of length the same as number of rows of matrix input is returned", {
  reacs <- data.frame(matrix(runif(30, 0, 10), 10, 3))
  expect_true(length(calcDis(reacs)) == nrow(reacs))
})

#' @title Plots differentially reactive regions.
#'
#' @description Given the table of results from dStruct or dStructGuided and the
#' corresponding lists with reactivity scores for all transcripts, this function saves
#' a PDF file with detailed visualizations of reactivities for all differential regions.
#'
#' @param rl List of dataframes of reactivities for each sample.
#' @param diff_regions Output from dStruct or dStructGuided containing coordinates of regions with significance of differentially reactivity.
#' @param outfile The name for pdf file which will be saved.
#' @param fdr FDR threshold for plotted regions.
#' @param ylim Y-axis limits for plots.
#' @param del_d_cutoff Minimum effect size for plotted regions specified in terms of median difference of the between-group and within-group d-scores.
#' @return Saves a PDF for all differentially reactive regions. Returns NULL.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA
#' structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' @examples
#' #Load data from Lai et al., 2019
#' data(lai2019)
#'
#' #Run dStruct in de novo discovery mode for all the transcripts in this data in one step.
#' res <- dStructome(lai2019, 3, 2, batches= TRUE, min_length = 21,
#'     between_combs = data.frame(c("A3", "B1", "B2")),
#'     within_combs = data.frame(c("A1", "A2", "A3")),
#'     ind_regions = TRUE, processes = 1)
#'
#' #Plot the significant results and save to a PDF file.
#' plotDStructurome(rl = lai2019,
#'     diff_regions = res,
#'     outfile = "significantly_differential_regions",
#'     fdr = 0.05,
#'     ylim = c(-0.05, 3))
#' @export
#' @importFrom grDevices  pdf dev.off
#' @importFrom rlang .data
plotDStructurome <- function(rl, diff_regions, outfile, fdr = 0.05, ylim = c(-0.05, 3),
                              del_d_cutoff = 0.01) {
  diff_regions <- data.frame(diff_regions)
  diff_regions <- subset(diff_regions, diff_regions$FDR < fdr &
                           diff_regions$del_d > del_d_cutoff)
  diff_t <- unique(diff_regions$t)

  grDevices::pdf(paste0(outfile, ".pdf"), width=7,height=6)
  for (i in 1:length(diff_t)) {
    curr_t <- as.character(diff_t[i])
    curr_regs <- subset(diff_regions, t == curr_t)
    curr_df <- rl[[curr_t]]

    print(ggplot2::ggplot(data=data.frame(x=0,y=0), ggplot2::aes(x=.data$x, y=.data$y)) +
            ggplot2::annotate("text", x = 4, y = 25,
                              label = curr_t) +
            ggplot2::theme_classic()+
            ggplot2::theme(axis.line=ggplot2::element_blank(),
                           axis.text.x=ggplot2::element_blank(),
                           axis.text.y=ggplot2::element_blank(),
                           axis.ticks=ggplot2::element_blank(),
                           axis.title.x=ggplot2::element_blank(),
                           axis.title.y=ggplot2::element_blank(),
                           legend.position="none",
                           panel.background=ggplot2::element_blank(),
                           panel.border=ggplot2::element_blank(),
                           panel.grid.major=ggplot2::element_blank(),
                           panel.grid.minor=ggplot2::element_blank(),
                           plot.background=ggplot2::element_blank())
    )

    dat <- data.frame(curr_df, n = 1:nrow(curr_df))
    dat <- reshape2::melt(dat, id.vars = "n")

    print(ggplot2::ggplot(dat, ggplot2::aes(x= .data$n, y= .data$value)) +
            ggplot2::geom_bar(stat="identity") +ggplot2::facet_grid(.data$variable~.)+
            ggplot2::coord_cartesian(ylim=ylim) +
            ggplot2::geom_rect(ggplot2::aes(NULL, NULL,
                                            xmin=.data$start-0.5,
                                            xmax=.data$end+0.5),
                               ymin= -Inf, ymax= Inf, data= curr_regs, fill= "red",
                               color= NA, alpha= 0.3) +
            ggplot2::theme(strip.text = ggplot2::element_text(size = 6),
                           legend.position = "none") +
            ggplot2::ggtitle(curr_t)+
            ggplot2::xlab("Nucleotide") + ggplot2::ylab("Reactivity"))


    for (r in 1:nrow(curr_regs)) {
      dat <- data.frame(curr_df[curr_regs$start[r]:curr_regs$end[r], ],
                       n = curr_regs$start[r]:curr_regs$end[r])
      dat <- reshape2::melt(dat, id.vars = "n")

      print(ggplot2::ggplot(dat, ggplot2::aes(x= .data$n, y= .data$value)) +
              ggplot2::geom_bar(stat="identity") +ggplot2::facet_grid(variable~.)+
              ggplot2::coord_cartesian(ylim=ylim) +
              ggplot2::theme(strip.text = ggplot2::element_text(size = 6),
                             legend.position = "none") +
              ggplot2::ggtitle(curr_t)+
              ggplot2::xlab("Nucleotide") + ggplot2::ylab("Reactivity"))
    }

  }
  grDevices::dev.off()
  return()
}

#' @title Constructs potential differentially reactive regions.
#'
#' @description This function takes between- and within-group \emph{d} scores for a
#' transcript as input and identifies regions where the former is generally larger.
#' Regions that pass minimum quality and minimum signal criteria are returned.
#'
#' @param d_within Nucleotide-wise d score for within-group variation.
#' @param d_spec Nucleotide-wise d score for between-group variation.
#' @param rdf Dataframe of reactivities for each sample.
#' @param min_length Minimum length of constructed regions.
#' @param check_signal_strength Logical, if TRUE, construction of regions must be based on nucleotides that have a minimum absolute value of reactivity.
#' @param check_nucs Logical, if TRUE, constructed regions must have a minimum number of nucleotides participating in Wilcoxon signed rank test.
#' @param check_quality Logical, if TRUE, check constructed regions for quality.
#' @param quality Worst allowed quality for a region to be tested.
#' @param evidence Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.
#' @param signal_strength Threshold for minimum signal strength.
#' @return Integer vector of nucleotides that constitute potential differentially reactive regions.
#'
#' @author Krishna Choudhary
#'
#' @references
#' Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
#' dStruct: identifying differentially reactive regions from RNA
#' structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
#'
#' @export
#' @importFrom utils tail
getRegions <- function(d_within, d_spec, rdf, min_length= 11,
                       check_signal_strength = TRUE, check_nucs = TRUE, check_quality = TRUE,
                       quality = 0.5, evidence = 0, signal_strength = 0.1) {

  if (check_signal_strength) {
    insufficient_signal <- apply(rdf, 1, function(x) all(abs(x) < signal_strength, na.rm=TRUE))
    d_within[insufficient_signal] <- NA
    d_spec[insufficient_signal] <- NA
  }

  #Set min_length to next odd integer.
  min_length <- if (min_length %% 2 == 0) min_length +1 else min_length

  to_test <- c()

  #How many nucleotides with information must a constructed region have.
  min_nucs <- min(min_length, 6)-1

  smooth_evidence <- zoo::rollapply(d_spec - d_within, width = min_length,
                                   FUN= function(x) mean(x, na.rm=TRUE))

  where_evidence <- smooth_evidence > evidence
  smooth_evidence[where_evidence] <- 1
  smooth_evidence[!where_evidence] <- 0

  evidence_rle <- rle(smooth_evidence)
  consider_regs <- which((evidence_rle$values == 1) & (evidence_rle$lengths >= min_length))

  for (i in consider_regs) {
    check_n <- check_nucs
    check_q <- check_quality

    if (i == 1) {
      start <- which(!is.na(d_within - d_spec))[1] + ((min_length-1)/2)
      end <- evidence_rle$lengths[1]+((min_length-1)/2)
    } else {
      start <- sum(evidence_rle$lengths[1:(i-1)]) + ((min_length-1)/2) + 1
      end <- sum(evidence_rle$lengths[1:(i)]) + ((min_length-1)/2)
    }

    #Trim nucleotides from end with very low reactivities, only if regions detected are not too short.
    if (end - start + 1 >= 11) {
      trim_reac <- apply(round(rdf[start:end, ], 2), 1,
                        function(x) all(abs(x) <= signal_strength, na.rm= TRUE))
      if (all(trim_reac)) next

      start <- start + which(!trim_reac)[1] - 1
      end <- end - length(trim_reac) + utils::tail(which(!trim_reac), 1)

      trim_reac <- is.na(d_within[start:end]-d_spec[start:end])
      if (all(trim_reac)) next
      start <- start + which(!trim_reac)[1] - 1
      end <- end - length(trim_reac) + utils::tail(which(!trim_reac), 1)
    }

    if (end - start + 1 < min_length) next


    if (check_n) {
      check_n <- sum(!is.na(c(d_within[start:end] - d_spec[start:end]))) > min_nucs

      #check_q can be NA if for example, reactivity were all 0s in a region.
      if (is.na(check_n)) check_n <- FALSE
    } else check_n <- TRUE

    if (check_n) curr_test <- start:end

    if (check_q) {
      check_q <- mean(d_within[start:end], na.rm= TRUE) <= quality

      #check_q can be NA if for example, reactivity were all 0s in a region.
      if (!is.na(check_q)) {
        #If the quality is not good for entire region, search for smaller regions that are good quality.
        if (!check_q) {
          wi_d <- zoo::rollapply(d_within[start:end], width = min_length,
                                FUN= function(x) mean(x), align= "left")
          if (any(wi_d <= quality, na.rm= TRUE))  {
            which_good <- start + which(wi_d <= quality) -1
            curr_test <- unique(unlist(purrr::map(which_good, function(x) x:(x+min_length-1))))
            check_q <- TRUE
          }
        }
      } else check_q <- FALSE
    } else check_q <- TRUE

    if (check_n & check_q) to_test <- c(to_test, start:end)

  }

  return(to_test)
}

test_that("Returns expected values of normalized reactivities", {
  expect_true(all(twoEightNormalize(c(NA, 1:20, NA, -999)) ==
                c(NA, (1:20)/19, NA, -999), na.rm = TRUE))
  expect_true(all(is.na(twoEightNormalize(c(NA, 1:20, NA, -999))[c(1, 22)])))

  expect_true(all(twoEightNormalize(c(NA, 1:10, NA, -999, NaN)) ==
                    c(NA, (1:10)/9.5, NA, -999, NaN), na.rm = TRUE))
  expect_true(all(is.na(twoEightNormalize(c(NA, 1:10, NA, -999, NaN))[c(1, 12, 14)])))

  expect_true(all(is.nan(twoEightNormalize(c(NA, 1:10, NA, -999, NaN))[14])))
})

---
title: "Differential RNA structurome analysis using `dStruct`"
author: 
- name: Krishna Choudhary
  affiliation: University of California, San Francisco, USA
  email: kchoudhary@ucdavis.edu
- name: Sharon Aviran
  affiliation: University of California, Davis, USA
package: dStruct
output: 
  BiocStyle::html_document:
    toc_float: true
  BiocStyle::pdf_document: default
vignette: >
  %\VignetteIndexEntry{Differential RNA structurome analysis using `dStruct`}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: "`r 'refs.bib'`"
abstract: > 
  <p> A large variety of RNA molecules exist in cells. They adopt diverse structures to serve important cellular functions. In the last decade, a number of deep sequencing-based technologies have been developed to study RNA structures at a genome-wide scale, at high resolution, and in vivo or in vitro. These technologies generate large-scale and highly noisy data. A common goal in many studies utilizing such data is to compare RNA structuromes under two or more conditions, and identify RNAs or their regions that may have altered structures between the conditions. 
  <p>`dStruct`: dStruct is a package meant for **d**ifferential analysis of RNA **Struct**urome profiling data [@choudhary2019dstruct]. It is broadly applicable to all existing technologies for RNA structurome profiling. It accounts for inherent biological variation in structuromes between replicate samples and returns differential regions. Here, we describe the input data format required by dStruct, provide use cases, and discuss options for analysis and visualization.
---
  
<style type="text/css">
.smaller {
  font-size: 15px
}
</style>
  
```{r echo = FALSE, message = FALSE, warning = FALSE}
library(BiocStyle)
```
  
*** 
  
For details on the methods presented here, consider having a look at our manuscript:
  
> Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019). dStruct: identifying differentially reactive regions from RNA structurome profiling data. Genome Biology, 20(1), 1-26. doi: [10.1186/s13059-019-1641-3](https://doi.org/10.1186/s13059-019-1641-3)
  
# Load packages {-}
  
The following code chunk loads the `dStruct` and `tidyverse` packages. We use `tidyverse` for cleaner code presentation in this vignette. 
  
```{r load-libs, message = FALSE,  warning = FALSE}
library(dStruct)
library(tidyverse)
```

# Introduction

dStruct is broadly applicable to technologies for RNA structurome profiling, e.g., SHAPE-Seq, Structure-Seq, PARS, SHAPE-MaP, etc. The raw data from these technologies are reads from DNA sequencing platforms. The start sites of read alignment coordinates are adjacent to sites of reactions of ribonucleotides with a structure-probing reagent. For some technologies, the sites of mismatches between reads and the reference genome sequences are sites of reactions, e.g., SHAPE-MaP and DMS-MaPseq. The counts of reads mapping to the nucleotides of an RNA should be tallied and converted to reactivities, which represent the degrees of reactions. The specific steps to process data from sequencing reads to reactivities depend on the structurome profiling technology. For a review on structurome profiling technologies and methods for assessing reactivities, see @choudhary2017comparative. 

dStruct takes nucleotide-level normalized reactivities of one or multiple RNAs as input. Currently, the preffered normalization method depends on the RNA structurome profiling technology. We have provided an implementation of the 2-8 % method for normalization (@low2010shape) via a function named `twoEightNormalize`, which is commonly used to normalize data from technologies such as SHAPE-Seq, Structure-Seq, etc. In the following, we assume that the user has processed the raw reads to obtain normalized reactivities for their RNAs of interest. 

# Input data

The input data to dStruct is a `list` object. Each element of the `list` should be a `data.frame` containing normalized reactivities.  

## Load inbuilt sample data

We have provided two test datasets with this package. These are derived from experiments described in @lai2019genome and @wan2014landscape. As described in the section on differential analysis below, we use these to illustrate de novo and guided discovery use cases, respectively. To start with, let us examine the data structure required for input. 

The Lai et al. data can be loaded as follows.

```{r}
data(lai2019)
```

This adds an object named `lai2019` to the global environment, which can be checked using the following function. 

```{r}
ls()
```

`lai2019` is an object of class `list`. Each of the list elements is a `data.frame` containing normalized reactivities.

```{r}
class(lai2019)
```

```{r}
names(lai2019) %>% head()
```

All elements of `lai2019` have the same structure. Let us check one of them. 

```{r}
class(lai2019[[1]])
```

```{r}
head(lai2019[["YAL042W"]], n= 20)
```

Each row of the above `data.frame` has the reactivity for one nucleotide of the RNA with id `"YAL042W"` and each column is one sample. Consecutive rows must represent consecutive nucleotides. `NA` values represent unavailable reactivities. If the data were generated using base-selective reagents (e.g., DMS used by Lai et al.), `dStruct` expects that the reactivities of unprobed bases have been masked as `NA` before running the differential analysis. 

Currently, `dStruct` supports comparisons of samples from two conditions at a time.  The prefixes `A` and `B` in the columns of each `data.frame` of `lai2019` stand for the two conditions. It is required that the conditions be labeled as `A` and `B` because `dStruct` will be looking for these internally. The numeric suffixes in the column names are replicate sample numbers. These must start with `1` and increase in steps of 1. If the samples were prepared in batches with each batch having one sample of each group, the corresponding samples should be given the same numeric suffix. 

# Differential analysis

Differential analysis can be performed for multiple RNAs in one step or a single RNA at a time. Additionally, we allow for two modes of analysis, one to identify differentially reactive regions de novo, and another called as guided discovery to assess the significance of differences in reactivities in the regions provided by the user. 

## De novo discovery

The function `dStruct` analyzes reactivity profiles for a single transcript to identify differential regions de novo. Additionally, we provide a wrapper function called `dStructome` which can analyze profiles for multiple transcripts simultaneously. For example, a single transcript, say `YAL042W`, can be analyzed as follows.

```{r, warning=FALSE}
dStruct(rdf = lai2019[["YAL042W"]],
        reps_A = 3, reps_B = 2,
        batches = TRUE, min_length = 21, 
        between_combs = data.frame(c("A3", "B1", "B2")),
        within_combs = data.frame(c("A1", "A2", "A3")),
        ind_regions = TRUE)
```
**Input arguments.** The arguments `rdf`, `reps_A` and `reps_B` of the `dStruct` function are required while the others are optional. These take in a `data.frame` with reactivity values, the number of samples of group A (group of wild-type *S. cerevisiae* samples), and the number of samples of group B (group of *dbp2$\Delta$ S. cerevisiae* samples), respectively. Set `batches` to `TRUE` if the samples were prepared in batches with a paired experiment design, i.e., two samples in each batch -- one of each group. `min_length` is the minimum length of a differential region that `dStruct` would search for. For the Lai et al. dataset, we set it to 21 nt because that is the putative length of regions bound by Dbp2, which was the RNA helicase under investigation in their study. As described in our manuscript, `dStruct` performs differential analysis by regrouping the samples in homogeneous and heterogeneous groups and assessing the dissimilarity of reactivity profiles in these groups. The homogeneous groups comprise of samples from the same original group (e.g., A or B) while the heterogeneous groups comprise of samples from both A and B, respectively (see @choudhary2019dstruct for details). Users can explicitly specify these groupings to the `dStruct` function as shown in the example above. Otherwise, `dStruct` would automatically generate the homogeneous and heterogeneous groups. Setting `ind_regions` to `TRUE` requires test for significance of difference in reactivity patterns in individual regions. If it is set to `FALSE` all regions identified within a transcript are tested collectively to obtain significance scores at the level of a transcript. 

**Output.** The output is an `IRanges` object with columns giving the start (column titled *start*) and end (column titled *end*) coordinates of the tested regions from the transcript whose reactivity profile is input, *p*-values, medians of nucleotide-wise differences of the between-group and within-group *d* scores (column titled *del_d*), and the FDR-adjusted *p*-values.

Alternatively, all transcripts in a reactivity list can be analyzed in one step using the wrapper function `dStructome`. By default, `dStructome` spawns multiple processes, which speeds up the analysis by processing transcripts in parallel. This behavior can be changed using the argument `processes` as shown in the following code chunk.
```{r, warning=FALSE}
res <- dStructome(lai2019, 3, 2, batches= TRUE, min_length = 21,
                  between_combs = data.frame(c("A3", "B1", "B2")),
                  within_combs = data.frame(c("A1", "A2", "A3")),
                  ind_regions = TRUE, processes = 1)
```
This returns the coordinates of regions in transcripts with the corresponding *p*- and FDR-values.
```{r}
head(res)
```

## Guided discovery

The function `dStructGuided` tests for differential reactivity profiles of pre-defined regions. Additionally, the wrapper function `dStructome` can analyze profiles for multiple regions simultaneously when its argument `method = "guided"`. 

We illustrate this mode of running `dStruct` using PARS data from @wan2014landscape. We downloaded the data reported in their manuscript and processed it to get PARS scores as described in @choudhary2019dstruct. The PARS scores are available with the `dStruct` package and can be loaded as follows.
```{r}
data(wan2014)
```
This adds an object named `wan2014` to the global environment, which can be checked using the following function. 

```{r}
ls()
```

`wan2014` is an object of class `list` and has the same structure as described for Lai et al.'s data above. Each of its elements is a `data.frame` containing PARS scores for an 11 nt region. At its center, each region has a single-nucleotide variant between the two groups of samples (the regions could be defined by users based on other considerations, e.g., regions bound by proteins based on assays such as eCLIP-seq). There are two samples of group A and one of group B.
```{r}
wan2014[[1]]
```
The names of the list elements give a transcript's ID and the coordinates of its region to be tested.
```{r}
names(wan2014) %>% head()
```
To test a single region, use `dStructGuided` as follows.
```{r}
dStructGuided(wan2014[[1]], 
               reps_A = 2, reps_B = 1)
```
`dStructGuided` returns a *p*-value for significance of differential PARS scores in the input region and the median of nucleotide-wise differences of the between-group and within-group *d* scores. Alternatively, all regions in `wan2014` can be analyzed in one step using the wrapper function `dStructome`.
```{r, warning=FALSE}
res_predefined_regs <- dStructome(wan2014, 
                                  reps_A = 2, reps_B = 1, method = "guided", 
                                  processes = 1)
```
This returns a table with the coordinates of regions in transcripts with the corresponding *p*- and FDR-values.
```{r}
head(res_predefined_regs)
```

# Visualizing results

The function `plotDStructurome` takes in a list of `data.frame`s with reactivities and the results from `dStructome` to save a PDF file showing the reactivities in a region. We illustrate this with the result for the `lai2019` data. Let us plot the reactivities for the gene with the lowest FDR value. We can identify it as follows.
```{r}
toPlot <- res@elementMetadata %>%
  data.frame() %$% 
  magrittr::extract(t, order(FDR)) %>% 
  head(., n = 1)

toPlot
```
Users may pass the entire reactivity list to `plotDStructurome` and the complete result table. By default, the results are plotted for FDR < 0.05 and $y$-axis limits range from 0 to 3. However, this may take some time in case there are a large number of differential regions. Here, we plot the reactivities for the gene in the object `toPlot`.
```{r, message=FALSE, warning=FALSE}
plotDStructurome(rl = lai2019[toPlot], 
                  diff_regions = subset(res, t == toPlot),
                  outfile = paste0("DRRs_in_", toPlot), 
                  fdr = 0.05, 
                  ylim = c(-0.05, 3))
```
This saves a PDF file named "DRRs_in_YJR045C.pdf" in the current working directory. 

# Session Information {-}

```{r}
sessionInfo()
```

# References {-}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDStructurome.R
\name{plotDStructurome}
\alias{plotDStructurome}
\title{Plots differentially reactive regions.}
\usage{
plotDStructurome(
  rl,
  diff_regions,
  outfile,
  fdr = 0.05,
  ylim = c(-0.05, 3),
  del_d_cutoff = 0.01
)
}
\arguments{
\item{rl}{List of dataframes of reactivities for each sample.}

\item{diff_regions}{Output from dStruct or dStructGuided containing coordinates of regions with significance of differentially reactivity.}

\item{outfile}{The name for pdf file which will be saved.}

\item{fdr}{FDR threshold for plotted regions.}

\item{ylim}{Y-axis limits for plots.}

\item{del_d_cutoff}{Minimum effect size for plotted regions specified in terms of median difference of the between-group and within-group d-scores.}
}
\value{
Saves a PDF for all differentially reactive regions. Returns NULL.
}
\description{
Given the table of results from dStruct or dStructGuided and the
corresponding lists with reactivity scores for all transcripts, this function saves
a PDF file with detailed visualizations of reactivities for all differential regions.
}
\examples{
#Load data from Lai et al., 2019
data(lai2019)

#Run dStruct in de novo discovery mode for all the transcripts in this data in one step.
res <- dStructome(lai2019, 3, 2, batches= TRUE, min_length = 21,
    between_combs = data.frame(c("A3", "B1", "B2")),
    within_combs = data.frame(c("A1", "A2", "A3")),
    ind_regions = TRUE, processes = 1)

#Plot the significant results and save to a PDF file.
plotDStructurome(rl = lai2019,
    diff_regions = res,
    outfile = "significantly_differential_regions",
    fdr = 0.05,
    ylim = c(-0.05, 3))
}
\references{
Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
dStruct: identifying differentially reactive regions from RNA
structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
}
\author{
Krishna Choudhary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dStructome.R
\name{dStructome}
\alias{dStructome}
\title{Performs de novo or guided discovery of differentially reactive regions for transcriptome-wide data.}
\usage{
dStructome(
  rl,
  reps_A,
  reps_B,
  batches = FALSE,
  min_length = 11,
  check_signal_strength = TRUE,
  check_nucs = TRUE,
  check_quality = TRUE,
  quality = "auto",
  evidence = 0,
  signal_strength = 0.1,
  within_combs = NULL,
  between_combs = NULL,
  ind_regions = TRUE,
  gap = 1,
  processes = "auto",
  method = "denovo",
  proximity_assisted = FALSE,
  proximity = 10,
  proximity_defined_length = 30
)
}
\arguments{
\item{rl}{List of dataframes of reactivities for each sample.}

\item{reps_A}{Number of replicates of group A.}

\item{reps_B}{Number of replicates of group B.}

\item{batches}{Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.}

\item{min_length}{Minimum length of constructed regions.}

\item{check_signal_strength}{Logical, if TRUE, construction of regions must be based on nucleotides that have a minimum absolute value of reactivity.}

\item{check_nucs}{Logical, if TRUE, constructed regions must have a minimum number of nucleotides participating in Wilcoxon signed rank test.}

\item{check_quality}{Logical, if TRUE, check constructed regions for quality.}

\item{quality}{Worst allowed quality for a region to be tested.}

\item{evidence}{Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.}

\item{signal_strength}{Threshold for minimum signal strength.}

\item{within_combs}{Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.}

\item{between_combs}{Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.}

\item{ind_regions}{Logical, if TRUE, test each region found in the transcript separately.}

\item{gap}{Integer. Join regions if they are separated by these many nucleotides.}

\item{processes}{Number of parallel processes to use.}

\item{method}{Character specifying either guided or de novo discovery approach.}

\item{proximity_assisted}{Logical, if TRUE, proximally located regions are tested together.}

\item{proximity}{Maximum distance between constructed regions for them to be considered proximal.}

\item{proximity_defined_length}{If performing a "proximity-assisted" test, minimum end-to-end length of a region to be tested.}
}
\value{
Constructs regions, reports p-value and median difference of between-group and within-group d-scores for each region, and FDR for them.
}
\description{
This function provides a convenient way to call the dStruct or
dStructGuided functions for multiple transcripts simultaneously. By default,
the transcripts are processed in using multiple parallel processes if available.
}
\examples{
#Load data from Lai et al., 2019
data(lai2019)

#Run dStruct in de novo discovery mode for all the transcripts in this data in one step.
dStructome(lai2019, 3, 2, batches= TRUE, min_length = 21,
    between_combs = data.frame(c("A3", "B1", "B2")),
    within_combs = data.frame(c("A1", "A2", "A3")),
    ind_regions = TRUE, processes = 1)

#Load data from Wan et al., 2014
data(wan2014)

#Run dStruct in guide discovery mode for all the transcript regions in this data in one step.
dStructome(wan2014, reps_A = 2, reps_B = 1, method = "guided", processes = 1)
}
\references{
Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
dStruct: identifying differentially reactive regions from RNA structurome
profiling data. \emph{Genome biology}, 20(1), 1-26.
}
\author{
Krishna Choudhary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getCombs.R
\name{getCombs}
\alias{getCombs}
\title{Identifies subgroupings of replicates for assessing within-group and between-group variation.}
\usage{
getCombs(
  reps_A,
  reps_B,
  batches = FALSE,
  between_combs = NULL,
  within_combs = NULL
)
}
\arguments{
\item{reps_A}{Number of replicates of group A.}

\item{reps_B}{Number of replicates of group B.}

\item{batches}{Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.}

\item{between_combs}{Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.}

\item{within_combs}{Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.}
}
\value{
List of two dataframes, containing groupings for within-group and between-group variation.
}
\description{
Regroup all the samples of A and B groups into homogoneous and
heterogeneous sub-groups. Each homogenous sub-group contains replicates of either
group A only or group B only. Each heterogeneous sub-group has a mix of samples from
both the groups A and B.
}
\examples{
#Get heterogeneous and homogeneous set combinations of samples when there are 2 samples of group A and 1 of group B.
getCombs(2, 1)
}
\references{
Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
dStruct: identifying differentially reactive regions from RNA
structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
}
\author{
Krishna Choudhary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{lai2019}
\alias{lai2019}
\title{\emph{Saccharomyces cerevisiae} Structure-seq data}
\format{
An object of class \code{"list"}.
}
\source{
Raw data from \href{https://doi.org/10.1534/genetics.119.302058}{Lai et al., 2019} in processed form.
}
\usage{
data("lai2019")
}
\description{
Data from a Structure-seq assay of five samples of \emph{S. cerevisiae}, three
of which were wild-type samples and two mutant samples. The data was
pre-processed to obtain DMS reactivities as described by Lai et al. (2019).
}
\examples{
data("lai2019")
}
\references{
Lai et al. (2019) Genetics, Vol. 212, 153–174
(\href{https://doi.org/10.1534/genetics.119.302058}{Genetics})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getRegions.R
\name{getRegions}
\alias{getRegions}
\title{Constructs potential differentially reactive regions.}
\usage{
getRegions(
  d_within,
  d_spec,
  rdf,
  min_length = 11,
  check_signal_strength = TRUE,
  check_nucs = TRUE,
  check_quality = TRUE,
  quality = 0.5,
  evidence = 0,
  signal_strength = 0.1
)
}
\arguments{
\item{d_within}{Nucleotide-wise d score for within-group variation.}

\item{d_spec}{Nucleotide-wise d score for between-group variation.}

\item{rdf}{Dataframe of reactivities for each sample.}

\item{min_length}{Minimum length of constructed regions.}

\item{check_signal_strength}{Logical, if TRUE, construction of regions must be based on nucleotides that have a minimum absolute value of reactivity.}

\item{check_nucs}{Logical, if TRUE, constructed regions must have a minimum number of nucleotides participating in Wilcoxon signed rank test.}

\item{check_quality}{Logical, if TRUE, check constructed regions for quality.}

\item{quality}{Worst allowed quality for a region to be tested.}

\item{evidence}{Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.}

\item{signal_strength}{Threshold for minimum signal strength.}
}
\value{
Integer vector of nucleotides that constitute potential differentially reactive regions.
}
\description{
This function takes between- and within-group \emph{d} scores for a
transcript as input and identifies regions where the former is generally larger.
Regions that pass minimum quality and minimum signal criteria are returned.
}
\references{
Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
dStruct: identifying differentially reactive regions from RNA
structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
}
\author{
Krishna Choudhary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dStruct.R
\name{dStruct}
\alias{dStruct}
\title{Performs de novo discovery of differentially reactive regions.}
\usage{
dStruct(
  rdf,
  reps_A,
  reps_B,
  batches = FALSE,
  min_length = 11,
  check_signal_strength = TRUE,
  check_nucs = TRUE,
  check_quality = TRUE,
  quality = "auto",
  evidence = 0,
  signal_strength = 0.1,
  within_combs = NULL,
  between_combs = NULL,
  ind_regions = TRUE,
  gap = 1,
  get_FDR = TRUE,
  proximity_assisted = FALSE,
  proximity = 10,
  proximity_defined_length = 30
)
}
\arguments{
\item{rdf}{Dataframe of reactivities for each sample.}

\item{reps_A}{Number of replicates of group A.}

\item{reps_B}{Number of replicates of group B.}

\item{batches}{Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.}

\item{min_length}{Minimum length of constructed regions.}

\item{check_signal_strength}{Logical, if TRUE, construction of regions must be based on nucleotides that have a minimum absolute value of reactivity.}

\item{check_nucs}{Logical, if TRUE, constructed regions must have a minimum number of nucleotides participating in Wilcoxon signed rank test.}

\item{check_quality}{Logical, if TRUE, check constructed regions for quality.}

\item{quality}{Worst allowed quality for a region to be tested.}

\item{evidence}{Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.}

\item{signal_strength}{Threshold for minimum signal strength.}

\item{within_combs}{Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.}

\item{between_combs}{Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.}

\item{ind_regions}{Logical, if TRUE, test each region found in the transcript separately.}

\item{gap}{Integer. Join regions if they are separated by these many nucleotides.}

\item{get_FDR}{Logical, if FALSE, FDR is not reported.}

\item{proximity_assisted}{Logical, if TRUE, proximally located regions are tested together.}

\item{proximity}{Maximum distance between constructed regions for them to be considered proximal.}

\item{proximity_defined_length}{If performing a "proximity-assisted" test, minimum end-to-end length of a region to be tested.}
}
\value{
Constructs regions, reports p-value and median difference of between-group and within-group d-scores for each region, and FDR for them.
}
\description{
This function takes reactivity profiles for samples of two groups
as input and identifies differentially reactive regions in three steps (see
Choudhary et al., \emph{Genome Biology}, 2019 for details). First, it regroups
the samples into homogeneous and heteregenous sub-groups, which are used to
compute the within-group and between-group nucleotide-wise \emph{d} scores.
Second, smoothed between- and within-group \emph{d} score profiles are compared
to construct candidate differential regions. Finally, unsmoothed between- and
within-group \emph{d} scores are compared using the Wilcoxon signed-rank test.
The resulting p-values quantify the significance of difference in reactivity
patterns between the two input groups.
}
\examples{
#Load data from Lai et al., 2019
data(lai2019)

#Run dStruct in de novo discovery mode for a transcript with id YAL042W.
dStruct(rdf = lai2019[["YAL042W"]], reps_A = 3, reps_B = 2,
    batches = TRUE, min_length = 21,
    between_combs = data.frame(c("A3", "B1", "B2")),
    within_combs = data.frame(c("A1", "A2", "A3")),
    ind_regions = TRUE)
}
\references{
Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
dStruct: identifying differentially reactive regions from RNA structurome
profiling data. \emph{Genome biology}, 20(1), 1-26.
}
\author{
Krishna Choudhary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{wan2014}
\alias{wan2014}
\title{\emph{Homo sapiens} PARS data}
\format{
An object of class \code{"list"}.
}
\source{
Counts data from \href{https://doi.org/10.1038/nature12946}{Wan et al., 2014} in processed form.
}
\usage{
data(wan2014)
}
\description{
Data from a PARS assay of a family trio of mother, father, and child. The
data was pre-processed to obtain PARS scores as described in Choudhary et al. (2019).
}
\examples{
data(wan2014)
}
\references{
Wan et al., Nature, 505, 706–709 (2014)
(\href{https://doi.org/10.1038/nature12946}{Nature})
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getContigRegions.R
\name{getContigRegions}
\alias{getContigRegions}
\title{Identifies contiguous regions from a list of nucleotide indices.}
\usage{
getContigRegions(x, gap = 0)
}
\arguments{
\item{x}{A vector of integers.}

\item{gap}{Include gaps in the ranges if they are shorter than or equal to this length.}
}
\value{
IRanges object storing start and end sites of continguous regions.
}
\description{
Given a sequence of nucleotide indices, this function returns integer ranges covered by the indices. There is an option to merge ranges if they are separated by less than a user-specified distance.
}
\examples{
#Convert an integer vector of nucleotide positions to an IRanges object containing the coordinates of contiguous regions.
nucleotide_positions <- c(1, 3, 2, 8, 4:7, 11:20)
getContigRegions(nucleotide_positions)

#Merge regions if their end points are within 3 nt of each other.
getContigRegions(nucleotide_positions, gap = 3)
}
\author{
Krishna Choudhary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dStructGuided.R
\name{dStructGuided}
\alias{dStructGuided}
\title{Performs guided discovery of differentially reactive regions.}
\usage{
dStructGuided(
  rdf,
  reps_A,
  reps_B,
  batches = FALSE,
  within_combs = NULL,
  between_combs = NULL,
  check_quality = TRUE,
  quality = "auto",
  evidence = 0
)
}
\arguments{
\item{rdf}{Dataframe of reactivities for each sample. Each column must be labelled as A1, A2, ..., B1, B2, ...}

\item{reps_A}{Number of replicates of group A.}

\item{reps_B}{Number of replicates of group B.}

\item{batches}{Logical suggesting if replicates of group A and B were performed in batches and are labelled accordingly. If TRUE, a heterogeneous/homogeneous subset may not have multiple samples from the same batch.}

\item{within_combs}{Data.frame with each column containing groupings of replicates of groups A or B, which will be used to assess within-group variation.}

\item{between_combs}{Dataframe with each column containing groupings of replicates of groups A and B, which will be used to assess between-group variation.}

\item{check_quality}{Logical, if TRUE, check regions for quality.}

\item{quality}{Worst allowed quality for a region to be tested.}

\item{evidence}{Minimum evidence of increase in variation from within-group comparisons to between-group comparisons for a region to be tested.}
}
\value{
p-value for the tested region (estimated using one-sided Wilcoxon signed rank test) and the median of nucleotide-wise difference of between-group and within-group d-scores.
}
\description{
This function takes as input reactivity profiles for a
transcript region from samples of two groups. First, it regroups the samples
into homogeneous and heteregenous sub-groups, which are used to compute the
within-group and between-group nucleotide-wise \emph{d} scores. If the
region meets the quality criteria, the between- and within-group \emph{d}
scores are compared using the Wilcoxon signed-rank test.
The resulting p-values quantify the significance of difference in reactivity
patterns between the two input groups.
}
\examples{
#Load Wan et al., 2014 data
data(wan2014)

#Run dStruct in the guided mode on first region in wan2014.
dStructGuided(wan2014[[1]], reps_A = 2, reps_B = 1)
}
\references{
Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
dStruct: identifying differentially reactive regions from RNA
structurome profiling data. \emph{Genome biology}, 20(1), 1-26.
}
\author{
Krishna Choudhary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dCombs.R
\name{dCombs}
\alias{dCombs}
\title{Assesses within-group or between-group variation.}
\usage{
dCombs(rdf, combs)
}
\arguments{
\item{rdf}{Data.frame of reactivities for each sample.}

\item{combs}{Data.frame with each column containing groupings of samples.}
}
\value{
Nucleotide-wise d scores.
}
\description{
Given the reactivity profiles for a transcript from multiple samples,
and a list of sample identifiers, this function computes the dissimilarity of
reactivity scores between the specified samples. These are returned as a sequence of
nucleotide-wise \emph{d} scores.
}
\examples{
#Example of a data frame with reactivities.
reacs <- data.frame(matrix(runif(30, 0, 10), 10, 3))

#The columns of data frame with must indicate sample grouping and id.
colnames(reacs) <- c("A1", "A2", "B1")

#Get nucleotide-wise dissimilarity scores for a set of samples.
dCombs(rdf = reacs, combs = data.frame(c("A1", "B1")))
}
\references{
Choudhary, K., Lai, Y. H., Tran, E. J., & Aviran, S. (2019).
dStruct: identifying differentially reactive regions from RNA structurome
profiling data. \emph{Genome biology}, 20(1), 1-26.
}
\author{
Krishna Choudhary
}
